SecurityTracker.com
    Home    |    View Topics    |    Search    |    Contact Us    |   

SecurityTracker
Archives


 


Category:   Application (Generic)  >   libXpm Vendors:   X.org
(Mandrake Issues Fix) libXpm Integer and Stack Overflows May Let Remote Users Execute Arbitrary Code
SecurityTracker Alert ID:  1011327
SecurityTracker URL:  http://securitytracker.com/id/1011327
CVE Reference:   CVE-2004-0687, CVE-2004-0688   (Links to External Site)
Date:  Sep 16 2004
Impact:   Execution of arbitrary code via network, User access via network
Fix Available:  Yes  Vendor Confirmed:  Yes  
Version(s): X11 R6.8.0
Description:   Some vulnerabilities were reported in libXpm. A remote user may be able to execute arbitrary code on applications that use libXpm.

The vendor reported that there are some integer overflows [CVE: CVE-2004-0687] and stack overflows [CVE: CVE-2004-0688] in the libXpm X Pixmap library, shipped as part of the X Window System.

A stack overflow is reported in xpmParseColors() in 'parse.c' that can be triggered by a specially crafted XPMv1 and XPMv2/3 file. A demonstration exploit file is available at:

http://scary.beasts.org/misc/doom.xpm

A stack overflow is reported in the reading of pixel values in the ParseAndPutPixels() function in 'create.c' and in the ParsePixels() function in 'parse.c'. A demonstration exploit file is available at:

http://scary.beasts.org/misc/doom2.xpm

An integer overflow is reported in the colorTable allocation in xpmParseColors() in 'parse.c'. The XpmCreateImageFromXpmImage, CreateXImage, ParsePixels, ParseAndPutPixels, and ParsePixels are affected.

The vendor credits Chris Evans with reporting these flaws. The advisory from Chris Evans is available at:

http://scary.beasts.org/security/CESA-2004-003.txt

Impact:   A remote user can create a specially crafted image file that, when processed by an application using libXpm, will execute arbitrary code on the target system with the privileges of the target application.
Solution:   Mandrake has released a fix.

Mandrakelinux 10.0:
b04f06bcbb1d68a0bb5a27a3409ab695 10.0/RPMS/libxpm4-3.4k-27.1.100mdk.i586.rpm
674d40df87b997be5be5b63088cc25f1 10.0/RPMS/libxpm4-devel-3.4k-27.1.100mdk.i586.rpm
6f384448d85afd56100e68608d307536 10.0/SRPMS/xpm-3.4k-27.1.100mdk.src.rpm

Mandrakelinux 10.0/AMD64:
6f384448d85afd56100e68608d307536 amd64/10.0/SRPMS/xpm-3.4k-27.1.100mdk.src.rpm
6fed4973b8a0f06a78176b35069d39d3 amd64/10.0/RPMS/lib64xpm4-3.4k-27.1.100mdk.amd64.rpm
72b965c6dbf0d3cdc437405c18c8d658 amd64/10.0/RPMS/lib64xpm4-devel-3.4k-27.1.100mdk.amd64.rpm

Corporate Server 2.1:
09d95b236c8bbe18e64a521c91edecea corporate/2.1/RPMS/libxpm4-3.4k-21.1.C21mdk.i586.rpm
f95679273cc924ceb8343f5abb637bbf corporate/2.1/RPMS/libxpm4-devel-3.4k-21.1.C21mdk.i586.rpm
93b631321701b3309cf47ca62f92b2b2 corporate/2.1/SRPMS/xpm-3.4k-21.1.C21mdk.src.rpm

Corporate Server 2.1/x86_64:
a98d3ac4aca9d273aec7d0df7affd389 x86_64/corporate/2.1/RPMS/libxpm4-3.4k-21.1.C21mdk.x86_64.rpm
d6aa250f8bb892ccc48e914085e8472f x86_64/corporate/2.1/RPMS/libxpm4-devel-3.4k-21.1.C21mdk.x86_64.rpm
93b631321701b3309cf47ca62f92b2b2 x86_64/corporate/2.1/SRPMS/xpm-3.4k-21.1.C21mdk.src.rpm

Mandrakelinux 9.2:
8d9a613ad0d381e0da4ea8b455dc81ef 9.2/RPMS/libxpm4-3.4k-27.1.92mdk.i586.rpm
f279c6c59dec9a85bc6d209931b2d9b1 9.2/RPMS/libxpm4-devel-3.4k-27.1.92mdk.i586.rpm
ae0fa1a38affc7cdbef9505db0bb8e79 9.2/SRPMS/xpm-3.4k-27.1.92mdk.src.rpm

Mandrakelinux 9.2/AMD64:
5f074ee2a98ebefedd94ce12c481469d amd64/9.2/RPMS/lib64xpm4-3.4k-27.1.92mdk.amd64.rpm
dab19b1fdec00205b18a3d0db64ae7ea amd64/9.2/RPMS/lib64xpm4-devel-3.4k-27.1.92mdk.amd64.rpm
ae0fa1a38affc7cdbef9505db0bb8e79 amd64/9.2/SRPMS/xpm-3.4k-27.1.92mdk.src.rpm

Vendor URL:  www.x.org/pub/X11R6.8.0/patches/README.xorg-CVE-2004-0687-0688.patch (Links to External Site)
Cause:   Boundary error
Underlying OS:  Linux (Mandriva/Mandrake)
Underlying OS Comments:  10.0, 9.2, Corporate Server 2.1

Message History:   This archive entry is a follow-up to the message listed below.
Sep 16 2004 libXpm Integer and Stack Overflows May Let Remote Users Execute Arbitrary Code



 Source Message Contents

Subject:  [Security Announce] MDKSA-2004:098 - Updated libxpm4 packages fix


This is a multi-part message in MIME format...

------------=_1095296924-12666-4681

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

 _______________________________________________________________________

                 Mandrakelinux Security Update Advisory
 _______________________________________________________________________

 Package name:           libxpm4
 Advisory ID:            MDKSA-2004:098
 Date:                   September 15th, 2004

 Affected versions:	 10.0, 9.2, Corporate Server 2.1
 ______________________________________________________________________

 Problem Description:

 Chris Evans found several stack and integer overflows in the libXpm code 
 of X.Org/XFree86 (from which the libxpm code is derived):
 
 Stack overflows (CAN-2004-0687):
 
 Careless use of strcat() in both the XPMv1 and XPMv2/3 xpmParseColors code 
 leads to a stack based overflow (parse.c).
 
 Stack overflow reading pixel values in ParseAndPutPixels (create.c) as
 well as ParsePixels (parse.c).
 
 Integer Overflows (CAN-2004-0688):
 
 Integer overflow allocating colorTable in xpmParseColors (parse.c) -
 probably a crashable but not exploitable offence.
 
 The updated packages have patches from Chris Evans and Matthieu Herrb
 to address these vulnerabilities.
 _______________________________________________________________________

 References:

  http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2004-0687
  http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2004-0688
 ______________________________________________________________________

 Updated Packages:
  
 Mandrakelinux 10.0:
 b04f06bcbb1d68a0bb5a27a3409ab695  10.0/RPMS/libxpm4-3.4k-27.1.100mdk.i586.rpm
 674d40df87b997be5be5b63088cc25f1  10.0/RPMS/libxpm4-devel-3.4k-27.1.100mdk.i586.rpm
 6f384448d85afd56100e68608d307536  10.0/SRPMS/xpm-3.4k-27.1.100mdk.src.rpm

 Mandrakelinux 10.0/AMD64:
 6f384448d85afd56100e68608d307536  amd64/10.0/SRPMS/xpm-3.4k-27.1.100mdk.src.rpm
 6fed4973b8a0f06a78176b35069d39d3  amd64/10.0/RPMS/lib64xpm4-3.4k-27.1.100mdk.amd64.rpm
 72b965c6dbf0d3cdc437405c18c8d658  amd64/10.0/RPMS/lib64xpm4-devel-3.4k-27.1.100mdk.amd64.rpm

 Corporate Server 2.1:
 09d95b236c8bbe18e64a521c91edecea  corporate/2.1/RPMS/libxpm4-3.4k-21.1.C21mdk.i586.rpm
 f95679273cc924ceb8343f5abb637bbf  corporate/2.1/RPMS/libxpm4-devel-3.4k-21.1.C21mdk.i586.rpm
 93b631321701b3309cf47ca62f92b2b2  corporate/2.1/SRPMS/xpm-3.4k-21.1.C21mdk.src.rpm

 Corporate Server 2.1/x86_64:
 a98d3ac4aca9d273aec7d0df7affd389  x86_64/corporate/2.1/RPMS/libxpm4-3.4k-21.1.C21mdk.x86_64.rpm
 d6aa250f8bb892ccc48e914085e8472f  x86_64/corporate/2.1/RPMS/libxpm4-devel-3.4k-21.1.C21mdk.x86_64.rpm
 93b631321701b3309cf47ca62f92b2b2  x86_64/corporate/2.1/SRPMS/xpm-3.4k-21.1.C21mdk.src.rpm

 Mandrakelinux 9.2:
 8d9a613ad0d381e0da4ea8b455dc81ef  9.2/RPMS/libxpm4-3.4k-27.1.92mdk.i586.rpm
 f279c6c59dec9a85bc6d209931b2d9b1  9.2/RPMS/libxpm4-devel-3.4k-27.1.92mdk.i586.rpm
 ae0fa1a38affc7cdbef9505db0bb8e79  9.2/SRPMS/xpm-3.4k-27.1.92mdk.src.rpm

 Mandrakelinux 9.2/AMD64:
 5f074ee2a98ebefedd94ce12c481469d  amd64/9.2/RPMS/lib64xpm4-3.4k-27.1.92mdk.amd64.rpm
 dab19b1fdec00205b18a3d0db64ae7ea  amd64/9.2/RPMS/lib64xpm4-devel-3.4k-27.1.92mdk.amd64.rpm
 ae0fa1a38affc7cdbef9505db0bb8e79  amd64/9.2/SRPMS/xpm-3.4k-27.1.92mdk.src.rpm
 _______________________________________________________________________

 To upgrade automatically use MandrakeUpdate or urpmi.  The verification
 of md5 checksums and GPG signatures is performed automatically for you.

 All packages are signed by Mandrakesoft for security.  You can obtain
 the GPG public key of the Mandrakelinux Security Team by executing:

  gpg --recv-keys --keyserver pgp.mit.edu 0x22458A98

 You can view other update advisories for Mandrakelinux at:

  http://www.mandrakesoft.com/security/advisories

 If you want to report vulnerabilities, please contact

  security_linux-mandrake.com

 Type Bits/KeyID     Date       User ID
 pub  1024D/22458A98 2000-07-10 Linux Mandrake Security Team
  <security linux-mandrake.com>
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.0.7 (GNU/Linux)

iD8DBQFBSOQemqjQ0CJFipgRAuH+AKDHy8+ZeUvf4Rl8X8GHbRzOehKsmgCfetSs
hAw4//2fCURxXAJZS47iE+w=
=b1dS
-----END PGP SIGNATURE-----


------------=_1095296924-12666-4681
Content-Type: text/plain; name="message.footer"
Content-Disposition: inline; filename="message.footer"
Content-Transfer-Encoding: 8bit

____________________________________________________
Want to buy your Pack or Services from MandrakeSoft? 
Go to http://www.mandrakestore.com
Join the Club : http://www.mandrakeclub.com
____________________________________________________

------------=_1095296924-12666-4681--

 
 


Go to the Top of This SecurityTracker Archive Page





Home   |    View Topics   |    Search   |    Contact Us

This web site uses cookies for web analytics. Learn More

Copyright 2021, SecurityGlobal.net LLC